C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                        SUBROUTINE READ_CO2(NHB)
C ******************************************************************
C$$$ SUBPROGRAM DOCUMENTATION BLOCK
C . . .

C SUBPROGRAM: READ_NHB READ AND DISTRIBUTE NHB FILE
C PRGRMMR: BLACK ORG: W/NP2 DATE: 98-10-22
C
C ABSTRACT:
C READ_NHB READS IN QUANTITIES FROM THE NHB FILE AND THEN
C DISTRIBUTES THEM TO THE OTHER NODES/PEs AS NEEDED
C
C PROGRAM HISTORY LOG:
C 97-??-?? MEYS - ORIGINATOR
C 97-08-?? BLACK - REWROTE FOR BENCHMARK
C 98-??-?? TUCCILLO - MODIFIED FOR SINGLE OR DOUBLE PRECISION
C
C USAGE: CALL READ_NHB FROM SUBROUTINE INIT
C INPUT ARGUMENT LIST:
C NHB: FILE NUMBER OF THE NHB FILE
C
C OUTPUT ARGUMENT LIST:
C NONE
C
C OUTPUT FILES:
C NONE
C
C SUBPROGRAMS CALLED:
C UNIQUE: DSTRB
C IDSTRB
C
C LIBRARY: NONE
C
C COMMON BLOCKS: CTLBLK
C LOOPS
C MASKS
C DYNAM
C PHYS2
C MAPOT1
C VRBLS
C CONTIN
C PVRBLS
C BOCO
C ACMCLH
C ACMCLD
C ACMPRE
C ACMRDL
C ACMRDS
C ACMSFC
C CLDWTR
C CNVCLD
C SOIL
C INDX
C
C ATTRIBUTES:
C LANGUAGE: FORTRAN 90
C MACHINE : IBM SP
C$$$
C
C-----------------------------------------------------------------------
C INCLUDE/SET PARAMETERS.
C-----------------------------------------------------------------------
      INCLUDE "parmeta"
      INCLUDE "parm.tbl"
      INCLUDE "parmsoil"
      INCLUDE "mpif.h"
      INCLUDE "mpp.h"

C-----------------------------------------------------------------------
                              P A R A M E T E R
     & (G=9.8,CM1=2937.4,CM2=4.9283,CM3=23.5518,EPS=0.622
C
CVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
C &, Q2INI=.01E0,EPSQ2=1.E-4,EPSQ=2.E-12,EPSWET=1.E-4
C &, Q2INI=1.0E0,EPSQ2=1.E-4,EPSQ=2.E-12,EPSWET=1.E-4
C &, Q2INI=.50E0,EPSQ2=1.E-4,EPSQ=2.E-12,EPSWET=1.E-4
C &, Q2INI=.01E0,EPSQ2=1.E-4,EPSQ=2.E-12,EPSWET=0.0E0
     &, Q2INI=.50,EPSQ2=2.E-2,EPSQ=2.E-12,EPSWET=0.0
CAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
     &, Z0LAND=.10,Z0SEA=.001,FCM=.00001
     &, DTR=0.1745329E-1,H360=360.0
     &, H1905=190.5,H105=105.0)
C
C-----------------------------------------------------------------------
                              P A R A M E T E R
     & (IMJM=IM*JM-JM/2,JMP1=JM+1,JAM=6+2*(JM-10),LB=2*IM+JM-3
     &, LM1=LM-1,LP1=LM+1,IMT=2*IM-1)
C
C-----------------------------------------------------------------------
C
C DECLARE VARIABLES
C
C-----------------------------------------------------------------------
                              L O G I C A L
     & RUN,RUNB,FIRST,RESTRT,SIGMA
C-----------------------------------------------------------------------
                              C H A R A C T E R *32
     & LABEL
                              C H A R A C T E R *40
     & CONTRL,FILALL,FILMST,FILTMP,FILTKE,FILUNV
     &,FILCLD,FILRAD,FILSFC
C-----------------------------------------------------------------------
                              I N T E G E R
     & IDATB(3)
C-----------------------------------------------------------------------
C
C INCLUDE COMMON BLOCKS.
C
      INCLUDE "CTLBLK.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "DYNAM.comm"
      INCLUDE "PHYS2.comm"
      INCLUDE "MAPOT1.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "CONTIN.comm"
      INCLUDE "PVRBLS.comm"
      INCLUDE "BOCO.comm"
      INCLUDE "ACMCLH.comm"
      INCLUDE "ACMCLD.comm"
      INCLUDE "ACMPRE.comm"
      INCLUDE "ACMRDL.comm"
      INCLUDE "ACMRDS.comm"
      INCLUDE "ACMSFC.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "CNVCLD.comm"
      INCLUDE "SOIL.comm"
      INCLUDE "INDX.comm"
      COMMON /RDFSAV/ EMISP,EMIST,XLATT,XLATP,Q19001,HP98,H3M6,
     * HP75,H6M2,HP537,H74E1,H15E1,Q14330,HP2,TWENTY,HNINE,
     * DEGRAD,HSIGMA,DAYSEC,RCO2,INITCO2,
     * CAO3SW(5),CAH2SW(5),CBSW(5),RACO2(242)
C-----------------------------------------------------------------------





C-----------------------------------------------------------------------
      INTEGER ISTAT(MPI_STATUS_SIZE)
C







C-----------------------------------------------------------------------
C
C DECLARE NAMELIST.
C
C***********************************************************************
C
CJFP ADAPTADO PARA A LEITURA DO ARQUIVO DE CO2 ANUAL
C A DATA INICIAL DO ARQUIVO E 1875
C********************************************************************

        OPEN(1,form='unformatted',FILE='co2.bin',
     1 ACCESS='sequential')

C-----------------------------------------------------------------------
C***
C*** DISTRIBUTE CO2 entre 1859 e 2100
C***
       DO M=1,242

        IF(MYPE.EQ.0)THEN
          READ(1) RACO2(M)
C WRITE(0,*)'READ CO2'
C WRITE(0,*) RACO2(M)
        ENDIF

       ENDDO

       CALL MPI_BCAST(RACO2(1),242,MPI_REAL,0,
     1 MPI_COMM_COMP,IRTN)

C le o indice do vetor para o tempo inicial

        OPEN(8,FORM='FORMATTED',FILE='tempo_init_co2.txt')
        READ(8,*)INITCO2
        WRITE(0,*)INITCO2

C-----------------------------------------------------------------------
C END OF SUBROUTINE READ_CO2
C
C-----------------------------------------------------------------------
      RETURN
      END

CJFP ****************************************************************
C FINAL DAS ALTERACOES DO PESQUERO
